using System;
using System.Runtime.InteropServices;/* Provides mappings between C# and native code */

/* This example will only work on Windows. As of 7/20 32 bit dotnet core Linux compatibility is limited */

namespace NumericalAlgorithmsGroup
{
    class tanfunc {

        /* NAG routine declarations copied from flcsdnet.cs*/

        [DllImport("NLW32273E_nag.dll")] /* Import from DLL, the C# compiler provides a rudimentary check of the signature */
        public static extern double S07AAF(
                                            ref double X,
                                            ref int IFAIL
                                            );

        public static void Main()
        {
            double tanresult;
            int ifail = 1;
            double x = Math.PI / 4;
            tanresult = S07AAF(ref x, ref ifail);
            if (ifail != 0) {
              Console.WriteLine("ifail = {0}", ifail);
            } else {
              Console.WriteLine("tan pi/4 = {0, 4:f2}", tanresult);
            }
        }
    }
}
